//bbs2chreaderۃpN
//ꕔ
//̃R[h̓CZX͂ɔȂ̂ƂƂ

//ӏUserAgent̏̂ߐcommon.jsC|[gKv܂B

function translationHttpRequest(aURLSpec, aListener, aReferrerSpec){
	this.uriSpec = aURLSpec;
	this.listener = aListener;
	this.referrerSpec = aReferrerSpec;
}

translationHttpRequest.prototype = {
	_ioService: Components.classes["@mozilla.org/network/io-service;1"]
					.getService(Components.interfaces.nsIIOService),
	_URI: Components.classes["@mozilla.org/network/standard-url;1"]
						.createInstance(Components.interfaces.nsIURI),
	_refURI: Components.classes["@mozilla.org/network/standard-url;1"]
						.createInstance(Components.interfaces.nsIURI),
	_bInputStream: Components.classes["@mozilla.org/binaryinputstream;1"]
						.createInstance(Components.interfaces.nsIBinaryInputStream),

	_channel: null,
	_loading: false,
	_data: "",
	_headers: null,


// ********** ********* 萔 ********** **********

	/**
	 * NGXgɑ User Agent 
	 * @return string
	 */
	get USER_AGENT(){ return translationCommon.UserAgent },


	/**
	 * s URL
	 * @return number
	 */
	get ERROR_BAD_URL(){ return 1 },

	/**
	 * ݂Ȃ URL
	 * @return number
	 */
	get ERROR_NOT_AVAILABLE(){ return 2 },

	/**
	 * NGXg̎s
	 * @return number
	 */
	get ERROR_FAILURE(){ return 3 },


// ********** ********* vpeB ********** **********


	/**
	 * NGXg̃X|X
	 * @return string
	 */
	get responseText(){
		return this._data;
	},


	/**
	 * NGXg HTTP Xe[^X
	 * @return number
	 */
	get status(){
		return this._channel.responseStatus;
	},

	/**
	 * X|Xwb_̃nbVz
	 * @return array
	 */
	get headers(){
		return this._headers;
	},

// ********** ********* \bh ********** **********

	/**
	 * HTTP GET Jn
	 */
	get: function(){
		this.getRange();
	},


	/**
	 *  GET
	 * w肾ƒʏGET
	 *
	 * @param aRange number Range
	 * @param aModifiedSince number If-Modified-Since
	 */
	getRange: function(aRange, aModifiedSince){
		this._channel = null;
		try{
			this._URI.spec = this.uriSpec;

//			this._channel = this._ioService.newChannelFromURI(this._URI)
//									.QueryInterface(Components.interfaces.nsIHttpChannel);
			var httpProtocolHandler = this._ioService.getProtocolHandler("http")
							.QueryInterface(Components.interfaces.nsIHttpProtocolHandler);
			this._channel = httpProtocolHandler.newProxiedChannel(this._URI, null)
									.QueryInterface(Components.interfaces.nsIHttpChannel);

			this._channel.loadFlags = this._channel.LOAD_NORMAL;
			this._channel.setRequestHeader("User-Agent", this.USER_AGENT, false);

				// t@̐ݒ
			if(this.referrerSpec){
				this._channel.setRequestHeader("Referer", this.referrerSpec, false);
				this._refURI.spec=this.referrerSpec;
				this._channel.referrer=this._refURI;
			}

			this._data = "";
			this._loading = true;
			this._headers = null;
		}catch(e){
			this.dump("onHttpError > ERROR_BAD_URL");
			this.listener.onHttpError(this.ERROR_BAD_URL);
			return;
		}

		try{
			this._channel.requestMethod = "GET";
			this._channel.asyncOpen(this, this);

			this.dump("GET > " + this._URI.spec);
			if(aRange && aModifiedSince){
				this.dump("RANGE If-Modified-Since > " + aModifiedSince);
				this.dump("RANGE Range > " + "bytes=" + aRange + "-");
			}
		}catch(e){
			this.dump("onHttpError > ERROR_FAILURE");
			this.listener.onHttpError(this.ERROR_FAILURE);		
		}
	},



	/**
	 * HTTP POST Jn(͕̂̂)
	 *
	 * @param aPostString string 镶
	 */
	post: function(aPostString){
		this._channel = null;
		try{
			this._URI.spec = this.uriSpec;
		
			this._channel = this._ioService.newChannelFromURI(this._URI)
									.QueryInterface(Components.interfaces.nsIHttpChannel);

			//http://lxr.mozilla.org/mozilla/source/netwerk/base/public/nsIRequest.idl
			this._channel.loadFlags = this._channel.LOAD_NORMAL;

			this._channel.setRequestHeader("User-Agent", this.USER_AGENT, false);
			this._channel.setRequestHeader("Content-Type", "application/x-www-form-urlencoded", false);

				// t@̐ݒ
			if(this.referrerSpec){
				this._channel.setRequestHeader("Referer", this.referrerSpec, false);
				this._refURI.spec=this.referrerSpec;
				this._channel.referrer=this._refURI;
			}
			this._data = "";
			this._loading = true;
			this._headers = null;
		}catch(e){
			this.dump("onHttpError > ERROR_BAD_URL");
			this.listener.onHttpError(this.ERROR_BAD_URL);
			return;
		}

		var strIStream = Components.classes["@mozilla.org/io/string-input-stream;1"]
								.createInstance(Components.interfaces.nsIStringInputStream)
		aPostString = String(aPostString);
		strIStream.setData(aPostString, aPostString.length);
		var seekStream = strIStream.QueryInterface(Components.interfaces.nsISeekableStream);
		seekStream.seek(0,0);

			// nsIUploadChannel ̏
		var uploadChannel = this._channel.QueryInterface(Components.interfaces.nsIUploadChannel);
		uploadChannel.setUploadStream(strIStream, /*null*/"application/x-www-urlencoded", -1);
		this.dump("POSTDATA > " + aPostString);

//		this._channel.setRequestHeader("Cache-Control", "no-cache", true);

		try{
			this._channel.requestMethod = "POST";
			this._channel.asyncOpen(this, this);

			this.dump("POST > " + this._URI.spec);
		}catch(e){
			this.dump("onHttpError > ERROR_FAILURE");
			this.listener.onHttpError(this.ERROR_FAILURE);		
		}
	},


	/**
	 * NGXg̒~
	 */
	abort: function(){
		this._loading = false;
	 	try{
			this.dump("abort");
			this._channel.cancel(0);
		}catch(e){}
	},


	/**
	 * X|Xwb_̒lԂ
	 *
	 * @param aHeader string X|Xwb_
	 * @return string
	 */
	getResponseHeader: function(aHeader){
	 	try{
			return this._channel.getResponseHeader(aHeader);
		}catch(e){}
		return "";
	},

	/**
	 * fobO_v
	 *
	 * @param aString string _v
	 */
	dump: function(aString){
		dump(aString+"\n")
	},


// ********** ********* implements nsIHttpHeaderVisitor ********** **********


	visitHeader: function(aHeader, aValue){
		this._headers[aHeader] = aValue;
		this.dump("Header >" + aHeader + " : " + aValue);
	},


// ********** ********* implements nsIStreamListener ********** **********


	onDataAvailable: function (aRequest, aContext, aInputStream, aOffset, aCount) {
		this._bInputStream.setInputStream(aInputStream);
		var availableData = this._bInputStream.readBytes(aCount);
		if(availableData!=null){
		availableData = availableData.replace(/\x00/g, "");
		}
		this._data += availableData;
		this.listener.onHttpDataAvailable(availableData);
	},

	onStartRequest: function(aRequest, aContext){
		this.dump("onHttpStart");
		this.listener.onHttpStart();
	},

	onStopRequest: function(aRequest, aContext, aStatus) {
		this._loading = false;
		this.dump(aRequest.status);
//		alert(this._channel.getRequestHeader("Cache-Control"));
		if(aStatus == 0){
			try{
					// X|Xwb_̎擾
				this._headers = new Array();
				this._channel.visitResponseHeaders(this);
				this.dump("onHttpStop > " + this._channel.responseStatus);
				this.listener.onHttpStop(this._data, this._channel.responseStatus);
			}catch(e){
				this.dump("onHttpError > ERROR_NOT_AVAILABLE\n\n"+e+"\n");
				this.listener.onHttpError(this.ERROR_NOT_AVAILABLE);
			}
		}else{
			this.dump("onHttpError > ERROR_NOT_AVAILABLE");
			this.listener.onHttpError(this.ERROR_NOT_AVAILABLE);
		}
	}
}
