function translationRDF(func){
this.func=func;
this.rdf=Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);

function getFolderPath(name){
return Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService).newFileURI(Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties).get(name,Components.interfaces.nsIFile).QueryInterface(Components.interfaces.nsILocalFile)).spec;
}

this.originalURL="chrome://translation/locale/default/translation.rdf";
this.itemname="translation.rdf";
this.url=getFolderPath("ProfD")+"/"+this.itemname;

try{
this.dataSource=this.rdf.GetDataSource(this.url)
this.dataSource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Refresh(false)
this.after();
}catch(e){
if(e.name=="NS_ERROR_FILE_NOT_FOUND"){
//t@CȂ
//CXg[̂
this.itemRDF=Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
this.itemDataSource=this.itemRDF.GetDataSource(this.originalURL)
this.itemDataSource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Refresh(false)
var sink=this.itemDataSource.QueryInterface(Components.interfaces.nsIRDFXMLSink);
sink.addXMLSinkObserver(this);
}
}
}

translationRDF.prototype={
onEndLoad:function(sink){
sink.removeXMLSinkObserver(this);
this.itemDataSource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).FlushTo(this.url);
this.dataSource=this.rdf.GetDataSource(this.url)
this.dataSource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Refresh(false)
this.after();
},
onBeginLoad:function(aSink){},
onInterrupt:function(aSink){},
onResume:function(aSink){},
onError:function(aSink, aStatus, aErrorMsg){ alert("error! " + aErrorMsg); },
after:function(){
var sink=this.dataSource.QueryInterface(Components.interfaces.nsIRDFXMLSink);
sink.addXMLSinkObserver(this.getObserver());
},
getObserver:function(){
return new translationRDFObserver(this.func);
}
}

function translationRDFObserver(func){
this.onEndLoad=function(sink){
sink.removeXMLSinkObserver(this);
func();
}
}

translationRDFObserver.prototype={
onBeginLoad:function(aSink){},
onInterrupt:function(aSink){},
onResume:function(aSink){},
onError:function(aSink, aStatus, aErrorMsg){ alert("error! " + aErrorMsg); }
}