const nsIWebBrowserPersist = Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1'].createInstance(Components.interfaces.nsIWebBrowserPersist);

var rdf;
var sitelist;
var itempath;
var changed = false;
var tt;

window.addEventListener('load',eventset,false);

function eventset(){
document.getElementById("window").addEventListener('dialogaccept',accept,false);
/*document.getElementById("inport").addEventListener('click',import_items,false);*/
document.getElementById("reset").addEventListener('click',reset,false);
document.getElementById("add").addEventListener('click',additem,false);
document.getElementById("delete").addEventListener('click',deleteitem,false);
document.getElementById("up").addEventListener('click',up,false);
document.getElementById("down").addEventListener('click',down,false);
document.getElementById("popupPosition").selectedIndex=translationPref.popupPosition;
rdf=new translationRDF(loadend);
}

function reset(){
tt=new translateText(rdf);
tt.util().reset(loadend);
changed=true;
}

function additem(){
var path=browseAddFile();
if(path!=null){
tt=new translateText(rdf);
tt.util().convert(convertFilePathToURI(path));
loadend();
changed=true;
}
return void(0)
}

function browseAddFile(){
var fpicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
fpicker.init(window, translationCommon.localizeText("selectAddFile"), fpicker.modeOpen);
fpicker.appendFilter(translationCommon.localizeText("rdfFile") + "(*.rdf,*.xml)", "*.rdf;*.xml");
fpicker.appendFilters(fpicker.filterAll);
var showResult = fpicker.show();
if(showResult == fpicker.returnOK){
return fpicker.file.path;	
}
return null;
}

function deleteitem(){
var index=document.getElementById("sitelist").selectedIndex;
if(index!=-1){
sitelist[index].util().deleteitem();
loadend();
document.getElementById("sitelist").selectedIndex=index;
changed=true;
}
}

function up(){
var index=document.getElementById("sitelist").selectedIndex;
if(index > 0){
sitelist[index].util().up();
loadend();
document.getElementById("sitelist").selectedIndex=index-1;
changed=true;
}
}

function down(){
var index=document.getElementById("sitelist").selectedIndex;
if(index!=-1 && index < document.getElementById("sitelist").childNodes.length){
sitelist[index].util().down();
loadend();
document.getElementById("sitelist").selectedIndex=index+1;
changed=true;
}
}

function loadend(){
document.getElementById("clearWhenDrop").checked=translationPref.clearWhenDrop;
document.getElementById("saveState").checked=translationPref.saveState;
document.getElementById("dropToTranslate").checked=translationPref.dropToTranslate;
document.getElementById('dropToTranslate').disabled=!document.getElementById("clearWhenDrop").checked;
while(document.getElementById("sitelist").childNodes.length > 0){
document.getElementById("sitelist").removeChild(document.getElementById("sitelist").childNodes.item(0))
}
tt=new translateText(rdf);
sitelist=tt.getSites();
for(i in sitelist){
var item=document.createElement("listitem");
item.setAttribute("label",sitelist[i].name);
item.setAttribute("value",sitelist[i].value);
item.setAttribute("tooltiptext",sitelist[i].name+"("+sitelist[i].engine+")"+"["+sitelist[i].value+"]");
document.getElementById("sitelist").appendChild(item);
}
}

function browseImportFile(){
var fpicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
fpicker.init(window, translationCommon.localizeText("selectImportFile"), fpicker.modeOpen);
fpicker.appendFilter(translationCommon.localizeText("rdfFile") + "(*.rdf,*.xml)", "*.rdf;*.xml");
fpicker.appendFilters(fpicker.filterAll);
var showResult = fpicker.show();
if(showResult == fpicker.returnOK){
return fpicker.file.path;	
}
return null;
}

var importRDF;

function import_items(){
path=browseImportFile();
if(path!=null){
tt.util().importRDF(convertFilePathToURI(path));
loadend();
changed=true;
}
}

function browseExportFile(){
var fpicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
fpicker.init(window,translationCommon.localizeText("selectExportFolder"),fpicker.modeSave);
fpicker.appendFilter(translationCommon.localizeText("rdfFile") + "(*.rdf,*.xml)","*.rdf;*.xml");
fpicker.appendFilters(fpicker.filterAll);
fpicker.defaultString = "export.rdf";
var showResult = fpicker.show();
if(showResult == fpicker.returnOK || showResult == fpicker.returnReplace){
return fpicker.file.path;
}
return null;
}

var exportRDF;

function export_items(){
exportRDF=rdf;
save();
}

function save(){
path=browseExportFile();
tt.util().exportRDF(convertFilePathToURI(path))
}

function accept(){
translationPref.popupPosition=document.getElementById("popupPosition").selectedIndex;
translationPref.clearWhenDrop=document.getElementById("clearWhenDrop").checked;
translationPref.saveState=document.getElementById("saveState").checked;
translationPref.dropToTranslate=document.getElementById("dropToTranslate").checked;
tt.util().flush();
if(changed){
//translationPref.setDefaultLangage(false);
}
}

function convertFilePathToURI(aFilePath) {
var tempLocalFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
tempLocalFile.initWithPath(aFilePath);
const ioService = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
return ioService.newFileURI(tempLocalFile).spec;
}

function convertURIToFilePath(aURI) {
var ioService = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
var fileHandler = ioService.getProtocolHandler('file').QueryInterface(Components.interfaces.nsIFileProtocolHandler);
tempLocalFile = fileHandler.getFileFromURLSpec(aURI);
return tempLocalFile.path;
}